#!/nfs/public/bin/sybperl
#
# Program:  hdname.pl       Description: Searches for tickets users have  
#                                        opened/closed.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/14/96   Version: 2.00

require "helpdesk.inc";

###########################################################
#  This subroutine builds the employee list and presents
#  it as a selection list.
###########################################################

sub employee_list
{
    &emp_login;
    $emp_str = "select personId, lastName, altName, email ";
    $emp_str = $emp_str . "from MPerson where altName != NULL and ";
    $emp_str = $emp_str . "termDate = NULL order by lastName";
    print "<select name=\"employee\" size=10>\n";
    &dbcmd ( $dbproc, $emp_str ) ;
    &dbsqlexec ($dbproc);
    &dbresults($dbproc) ;
    while ( @data = &dbnextrow($dbproc))
    {
      $personId =    $data[0] ;
      $name =  $data[2]." ".$data[1];
      $email = $data[3];
      print "<option value=$personId>$name\n";
    }
    print "</select>\n";
}

#############################################################
# Pull apart query string that hdname.html sent
#############################################################

&do_ask;
$buffer=$ENV{'QUERY_STRING'};
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value=~ tr/+/ /;
  $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}
$status=$FORM{"status"};
$nam=$FORM{"employee"};
$nam =~ tr/a-z/A-Z/;
if( $nam == 0 ) {
  exit;
}
&emp_login;
&get_emp;

########################################################################
#  Search for any tickets that have the submitterId and not closed
########################################################################

#print "Content-type: text/html\n\n";
#print "$employee, $personId, $nam\n";
#exit;
if( $status eq "A" ) {
  &helpdesk_login;
  $str="select * from OTicket where status != \"C\" and (submitterId=$nam or upper(submitLastName) = upper(\"$lname\"))";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data=&dbnextrow($dbproc)) {
      &do_point(@data);
    }
  }
  print "</html>\n";
  exit;
}

########################################################################
#  Search for any tickets that have the submitterId and closed
########################################################################

if( $status eq "C" ) {
  &helpdesk_login;
  $str="select * from OTicket where status = \"C\" and (submitterId = $nam or upper(submitLastName) = upper(\"$lname\"))";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data=&dbnextrow($dbproc)) {
      &do_point(@data);
    }
  }
  print "</html>\n";
  exit;
}

#########################################################
#do the isql query
#########################################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

#######################################################
#  This redisplays the options to select new submitter
#######################################################

sub do_ask {
print "Content-type: text/html\n\n";
print "

<head>
<title>Systems Help Desk Ticket Lookup</title>
</head>
<body bgcolor=\"FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
<center>
<h1>Systems Help Desk Ticket Lookup</h1>
<font size=2>Comments, questions, suggestions, problems should be directed
to <a href=\"mailto:$WEBMSTR\">$WEBMSTR</a>
</center>
</font>
<hr>
<form METHOD=\"put\" ACTION = \"$CGIDIR/hdname.pl\">";
&employee_list;
print "
Ticket Status:  <select name=\"status\">
<option value=\"A\">Open
<option value=\"C\">Closed
</select>
<br>
<br>
<br>
<center><td><input type=\"submit\" value = \"Submit\"></td></center>
";
}

#######################################################
#  This subroutine displays the ticket number href'd 
#######################################################

sub do_point {
@tmp=@_;
#printf "Ticket owner: %s %s",$tmp[8],$tmp[9];
printf "Ticket owner: %s %s <a href=\"hdstatus.pl?ticknum=%d\">%5.5d</a>
<br>
Request:
%s
<br><br>\n", $tmp[8],$tmp[9],$tmp[0], $tmp[0], $tmp[6];
}

sub get_emp
{
  $emp_str = "select lastName, altName, email ";
  $emp_str = $emp_str . "from MPerson where personId = $nam";
  &dbcmd ( $dbproc, $emp_str ) ;
  &dbsqlexec ($dbproc);
  &dbresults($dbproc) ;
  @data = &dbnextrow($dbproc);
  $lname =  $data[0] ;
  $fname =  $data[1];
  $email = $data[2];
}
