#!/nfs/public/bin/sybperl
#
# Program:  hdstatus.pl      Description:  Displays helpdesk ticket master
#                                          record with all of the detail 
#                                          records.  Used by users to check
#                                          ticket statuses.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/16/96   Version: 2.00
#

require "helpdesk.inc" ;

#################################################################
#  Parse info sent by hdstatus.html
#################################################################

$in = $ENV{'QUERY_STRING'};
($ticknum) = split(/&/,$in);
@tmp=split(/=/,$ticknum);
$ticknum=$tmp[1];

#################################################################
#  Display error message if ticket is 0
#################################################################

if($ticknum eq "" || $ticknum eq 0) {
  print "Content-type: text/html\n\n";
  print "<body  bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">\n";
  print "<center><h2>You MUST enter a Ticket number!</h2></center>\n";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<center><a href=\"$CGIDIR/hdstatusHTML.pl\">Try Again.</a></center>
\n";
  print "</html>\n";
  exit;
}
###########################################################
#  Get master record and all detail from the database
###########################################################

&helpdesk_login;
$str="select * from OTicket where ticketId = $ticknum";
&dbcmd($dbproc, $str);
&dbresults($dbproc);
&dbsqlexec ($dbproc);
if(&dbresults($dbproc)==&SUCCEED) {
  @data=&dbnextrow($dbproc);
  &do_html(@data);
}
&do_htmlhead;
$str="select * from CTicket where ticketId = $ticknum";
&do_isql;
while(@data=&dbnextrow($dbproc)) {
  &do_html1(@data);
}
&end_html;

#########################################################
#   Do the isql query
#########################################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

#######################################################
#  Display master record information (OTicket)
#######################################################

sub do_html {
@tmp=@_;
print "Content-type: text/html\n\n";
printf "
  <head>
  <title>Problem Ticket Maintenance</title>
  </head>
  <body  bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
  <center><h1>Problem Ticket Number %d</h1></center>
  <table border>
  <tr>
  <td><b>Submitted by:</b>  %s %s</td> 
  <td><b>Date Submitted:</b> %s</td> 
  <td><b>Date Needed:</b> %s</td> 
  </tr>
  <tr>
  <td><b>Status:</b>  %s</td>  
  <td><b>Department:</b> %s</td> 
  <td><b>Problem Type:</b> %s</td>
  </tr> 
  <tr>
  <td><b>Priority:</b>  %s</td>
  </tr>
  </table>
   ",$tmp[0],$tmp[8],$tmp[9],$tmp[1],$tmp[2],$tmp[3],$tmp[4],$tmp[5],$tmp[10];
  $tmp[6]=~ s/\n/\<br\>/g;
printf "
  <p>
  <p>
  <b>Request Description:</b>
  <table>
  <tr>
  <td>%s %s</td>
  </tr>
  </table>
  <hr>
  Key:<br>
  Status:  A=Assigned, U=Unassigned, C=Closed<br>
  Priority: 5=Highest ... 1=Lowest<br>
  Problem Type: M=Mac, U=Unix, P=MS-Dos/Windows, T=Telephone, S=Software, O=Other<br>
  <hr>
  <table border>
  ",$tmp[6], $tmp[7];
}

#######################################################
#  Display detail record heading
#######################################################

sub do_htmlhead {

printf "
  <th>Date</th><th>Done By</th><th>Description</th><th>Status</th>"
}

#######################################################
#  Display detail record information (CTicket)
#######################################################

sub do_html1 {
@tmp=@_;
printf "
  <tr>
  <td>%s</td><td>%s</td><td>%s %s</td><td>%s</td>
  </tr>
  ", $tmp[3], $tmp[4], $tmp[2], $tmp[7], $tmp[6];  
}
   
#######################################################
#  Display ending of html document
#######################################################

sub end_html {
printf " 
  </table>
  <center>
  <h3><a href=\"$CGIDIR/hdstatusHTML.pl\">
  <img src=\"/icons/blank.gif\"><br>
  DONE</h3>
  </center></a>
  </body>
  </html>";
}
