#!/nfs/public/bin/sybperl
#
# Program:  helpdesk.pl      Description:  Builds appropriate selection lists
#                                          and displays form for user to fill
#                                          out helpdesk ticket.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/16/96   Version: 2.00
 
require "helpdesk.inc";
 
&do_form;

##########################################################
#  Build select list of employees 
##########################################################

sub employee_list
{
    &emp_login;
    $emp_str = "select personId, lastName, altName, email ";
    $emp_str = $emp_str . "from MPerson where altName != NULL and ";
    $emp_str = $emp_str . "termDate = NULL order by lastName";
    print "<select name=\"employee\" size=10>\n";
    &dbcmd ( $dbproc, $emp_str ) ;
    &dbsqlexec ($dbproc);
    &dbresults($dbproc) ;
    while ( @data = &dbnextrow($dbproc)) 
    {
      $personId =    $data[0] ;
      $name =  $data[2]." ".$data[1]; 
      $email = $data[3];
      print "<option value=$personId>$name\n";	
    }
    print "</select>\n";
}

##########################################################
#  Build select list of Problem Types
##########################################################

sub problem_list 
{
    &helpdesk_login;
    $emp_str = "select problemTypeId, typeDescription ";
    $emp_str = $emp_str . "from ProblemTypes ";
    print "<select name=\"problemType\" size=10>\n";
    &dbcmd ( $dbproc, $emp_str ) ;
    &dbsqlexec ($dbproc);
    &dbresults($dbproc) ;
    while ( @data = &dbnextrow($dbproc)) 
    {
      $problemTypeId =    $data[0];
      $typeDescription =  $data[1]; 
      print "<option value=$problemTypeId>$typeDescription\n";	
    }
    print "</select>\n";
}

##########################################################
#  Display form for users to fill out
##########################################################

sub do_form
{
print "Content-type: text/html\n\n
<html>
<head>
<title>Systems/Phone Help Request Form</title>
</head>
<body bgcolor=\"FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
<center>
<h2>Systems Help Desk Request Form</h2>
<font size=2>Comments, questions, suggestions, problems should be directed
to <a href=\"mailto:$WEBMSTR\">$WEBMSTR</a> 
</center>
<hr>
<form METHOD=post ACTION = \"$CGIDIR/helpdesk1.pl\">
<center><table><tr><td>Ticket Submitter (YOU!):</td><td></td><td></td><td>Problem Type</td></tr><tr><td>";
&employee_list;
print "</td><td></td><td></td><td>";
&problem_list;
print "</td></tr></table>";
print "<br>
Date Needed By: <input name=\"dateNeededBy\" size=8>
Priority: <select input name=\"priority\" size=1>
<option value=\"0\">Pick One
<option value=\"5\">Highest
<option value=\"4\">Very High
<option value=\"3\">Important
<option value=\"2\">Please Do
<option value=\"1\">Put on Things to do List
</select>
<hr>
<p>
Request Description:
<textarea name=\"requestDescription\" maxlength=512 rows=15 cols=65>
</textarea>
<hr>
<center>
<td><input type=submit value = \"Submit\"></td>
</center>
</form>
</body>
</html>\n";
}

