use Helpdesk
go

CREATE TABLE CTicket (
       ticketId             numeric(9,0) NOT NULL,
       occurance            numeric(9,0) IDENTITY,
       resolution           varchar(255) NULL,
       lastModifyDate       smalldatetime NULL,
       assignedTo           varchar(64) NULL,
       keyWords             varchar(80) NULL,
       statusChange         varchar(1) NULL,
       resolution1          varchar(255) NULL,
       timeSpent            smallmoney NULL,
       ownerId              smallint NULL,
       PRIMARY KEY (ticketId, occurance)
)
go


CREATE TABLE OTicket (
       ticketId             numeric(9,0) IDENTITY,
       submitDate           smalldatetime NULL,
       dateNeededBy         varchar(10) NULL,
       status               varchar(1) NULL,
       department           varchar(30) NULL,
       problemType          varchar(1) NULL,
       requestDescription   varchar(255) NULL,
       requestDescription2  varchar(255) NULL,
       submitFirstName      varchar(64) NULL,
       submitLastName       varchar(64) NULL,
       priority             varchar(2) NULL,
       assigned             varchar(64) NULL,
       eMail                varchar(25) NULL,
       ownerId              smallint NULL,
       problemTypeId        smallint NULL,
       submitterId          smallint NULL,
       PRIMARY KEY (ticketId)
)
go


CREATE TABLE Owner (
       ownerId              smallint NOT NULL,
       ownerName            varchar(25) NULL,
       ownerEmail           varchar(25) NULL,
       PRIMARY KEY (ownerId)
)
go


CREATE TABLE ProblemTypes (
       problemTypeId        smallint NOT NULL,
       typeDescription      varchar(20) NULL,
       PRIMARY KEY (problemTypeId)
)
go


CREATE TABLE Department (
       departmentId         int NOT NULL,
       deptName             varchar(25) NULL,
       PRIMARY KEY (departmentId)
)
go


CREATE TABLE DepartmentPeople (
       departmentPeopleId   int NOT NULL,
       departmentId         int NULL,
       personId             int NULL,
       termDate             smalldatetime NULL,
       PRIMARY KEY (departmentPeopleId)
)
go


CREATE TABLE MPerson (
       personId             int NOT NULL,
       lastName             varchar(25) NULL,
       altName              varchar(25) NULL,
       email                varchar(25) NULL,
       termDate             smalldatetime NULL,
       PRIMARY KEY (personId)
)
go
